//
//  MOPathMenuController.h
//  MOPathMenuController
//
//  Created by mo jun on 3/4/13.
//  Copyright (c) 2013 mo jun. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <QuartzCore/QuartzCore.h>

#define kMenuFullWidthLeft 320.0f
#define kMenuFullWidthRight 320.0f
#define kMenuDisplayedWidth 280.0f
#define kMenuOverlayWidth (self.view.bounds.size.width - kMenuDisplayedWidth)
#define kMenuBounceOffset 10.0f
#define kMenuBounceDuration .3f
#define kMenuSlideDuration .3f
#define kMenuSliderTiggerWidth 50.0f

typedef NS_ENUM(NSInteger, DDMenuPanDirection) {
    DDMenuPanDirectionLeft = 0,
    DDMenuPanDirectionRight
};

typedef NS_ENUM(NSInteger, DDMenuPanCompletion) {
    DDMenuPanCompletionRoot = 0,
    DDMenuPanCompletionLeft,
    DDMenuPanCompletionRight
};

typedef NS_ENUM(NSInteger, PreDDMenuPanStatePosition) {
    PreDDMenuPanStatePositionRoot = 0,
    PreDDMenuPanStatePositionLeft,
    PreDDMenuPanStatePositionRight
};

@class MOPathMenuController;

@protocol MOPathMenuControllerDelegate <NSObject>

- (void)menuController:(MOPathMenuController *)controller willShowViewController:(UIViewController *)controller;

@end

@interface MOPathMenuController : UIViewController<UIGestureRecognizerDelegate>{
    UIPanGestureRecognizer *_pan;
    UITapGestureRecognizer *_tap;
    UIPanGestureRecognizer *_maskPan;
    
    CGFloat _panOriginX;
    CGPoint _panVelocity;
    DDMenuPanDirection _panDirection;
    PreDDMenuPanStatePosition _prePosition;
    
    struct {
        unsigned int respondsToWillShowViewController:1;
        unsigned int showingLeftView:1;
        unsigned int showingRightView:1;
        unsigned int canShowRight:1;
        unsigned int canShowLeft:1;
    }_menuFlags;
    
    UIView *panMaskView;
    
}

@property (nonatomic, retain) UIViewController *rootController;
@property (nonatomic, retain) UIViewController *leftController;
@property (nonatomic, retain) UIViewController *rightController;

@property (nonatomic, retain) UIPanGestureRecognizer *pan;
@property (nonatomic, retain) UITapGestureRecognizer *tap;
@property (nonatomic, retain) UIPanGestureRecognizer *maskPan;

@property (nonatomic, assign) CGFloat duration;

@property (nonatomic, assign) id<MOPathMenuControllerDelegate>delegate;

@property (nonatomic, assign) BOOL isDisplayShadow;

- (id)initWithRootViewController:(UIViewController*)controller;

@end
